#include "BasicMino.h"

CMino::MinoResult CBasicMino::Start()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	CMino::Start(); // x[XNX

	m_bLocked = false;
	if(m_pField->SetMinoBlocksToStartPosition(*m_pMinoBlocks)){
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}else{
		UpdateGhostMinoBlocks();
		return 0;
	}
}

CMino::MinoResult CBasicMino::Left()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	m_pMinoBlocks->GetBaseCoordinate().x -= 1;
	if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
		UpdateGhostMinoBlocks();
		m_bTSpin = false; // ړĂ܂ATSpinɂ͂ȂȂ
		m_bWallKick = false;
		return CMino::SUCCESS;
	}else{
		// ɈړoȂ
		m_pMinoBlocks->GetBaseCoordinate().x += 1; // ɖ߂
		return 0;
	}
}

CMino::MinoResult CBasicMino::Right()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	m_pMinoBlocks->GetBaseCoordinate().x += 1;
	if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
		UpdateGhostMinoBlocks();
		m_bTSpin = false; // ړĂ܂ATSpinɂ͂ȂȂ
		m_bWallKick = false;
		return CMino::SUCCESS;
	}else{
		// EɈړoȂ
		m_pMinoBlocks->GetBaseCoordinate().x -= 1; // ɖ߂
		return 0;
	}
}

CMino::MinoResult CBasicMino::Down()
{
	MinoResult result = Fall();
	if(result & CMino::SUCCESS){
		m_bTSpin = false; // łɈړATSpinɂ͂ȂȂ
		m_bWallKick = false;
	}
	return result;
}

CMino::MinoResult CBasicMino::HardDrop()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	MinoResult result = 0;

	while((result & CMino::LOCKED) == 0){
		result = Fall();
		if(result & CMino::SUCCESS){
			m_nHardDropHeight += 1; // }XL^
		}
	}

	return result;
}

CMino::MinoResult CBasicMino::Fall()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	m_pMinoBlocks->GetBaseCoordinate().y += 1;
	if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
		return CMino::SUCCESS;
	}else{
		// ɈړoȂˌŒ
		m_pMinoBlocks->GetBaseCoordinate().y -= 1; // ɖ߂
		m_pField->SetBlockState(*m_pMinoBlocks);
		m_bLocked = true;
		return CMino::LOCKED;
	}
}

ETetrisBlockState CBasicMino::GetBlockState(const CPoint2D<int> &rPt) const
{
	ETetrisBlockState state = BLOCKSTATE_NONE;

	if(!m_pMinoBlocks){
		return BLOCKSTATE_NONE;
	}

	state = m_pMinoBlocks->GetBlockState(rPt, true);
	if(state != BLOCKSTATE_NONE){
		return state;
	}

	if(!m_pGhostMinoBlocks){
		return BLOCKSTATE_NONE;
	}

	return m_pGhostMinoBlocks->GetBlockState(rPt, true);
}

bool CBasicMino::IsOnFloor(CPoint2D<int> &rPt) const
{
	bool bRes = false;

	if(!m_pField || !m_pMinoBlocks){
		return false;
	}

	m_pMinoBlocks->GetBaseCoordinate().y += 1; // Ɉړ

	unsigned int i = 0;
	ETetrisBlockState blockState = BLOCKSTATE_NONE;
	CPoint2D<int> pt;
	for(i=0; i<m_pMinoBlocks->GetBlockNum(); i++){
		// ܂MinoBlocksIuWFNgBlock̍W΍WŎ擾
		m_pMinoBlocks->GetBlock(i, pt, blockState, true);
		// ̍WBlock邩`FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			if(bRes){
				// ڈȏ
				if(pt.y > rPt.y){
					rPt = pt;
				}
			}else{
				rPt = pt;
			}
			bRes = true;
		}
	}
	m_pMinoBlocks->GetBaseCoordinate().y -= 1; // ɖ߂

	return bRes;
}

void CBasicMino::UpdateGhostMinoBlocks()
{
	if(!m_pField || !m_pMinoBlocks){
		if(m_pGhostMinoBlocks){
			delete m_pGhostMinoBlocks;
			m_pGhostMinoBlocks = NULL;
		}
		return;
	}

	// S[Xg̃ubŃAɂȂĂȂƂȂ
	if(!m_pGhostMinoBlocks){
		m_pGhostMinoBlocks = new CMinoBlocks(m_pMinoBlocks->GetBlockNum());
	}

	if(m_pMinoBlocks->GetBlockNum() != m_pGhostMinoBlocks->GetBlockNum()){
		delete m_pGhostMinoBlocks;
		m_pGhostMinoBlocks = new CMinoBlocks(m_pMinoBlocks->GetBlockNum());
	}

	// Rs[
	m_pGhostMinoBlocks->Copy(*m_pMinoBlocks);
	// ubN̐FAS[XgFɂ
	{
		unsigned int i = 0;
		for(i=0; i<m_pGhostMinoBlocks->GetBlockNum(); i++){
			ETetrisBlockState state = BLOCKSTATE_NONE;
			CPoint2D<int> pt;
			m_pGhostMinoBlocks->GetBlock(i, pt, state, true);
			switch(state){
			case BLOCKSTATE_CYAN:
				state = BLOCKSTATE_CYAN_G; break;
			case BLOCKSTATE_YELLOW:
				state = BLOCKSTATE_YELLOW_G; break;
			case BLOCKSTATE_GREEN:
				state = BLOCKSTATE_GREEN_G; break;
			case BLOCKSTATE_RED:
				state = BLOCKSTATE_RED_G; break;
			case BLOCKSTATE_BLUE:
				state = BLOCKSTATE_BLUE_G; break;
			case BLOCKSTATE_ORANGE:
				state = BLOCKSTATE_ORANGE_G; break;
			case BLOCKSTATE_MAGENTA:
				state = BLOCKSTATE_MAGENTA_G; break;
			default:
				break;
			}
			m_pGhostMinoBlocks->SetBlock(i, pt, state, true);
		}
	}

	// ȂȂ܂ŁA^Ɉړ
	do{
		m_pGhostMinoBlocks->GetBaseCoordinate().y += 1;
	}while(m_pField->CheckOverlap(*m_pGhostMinoBlocks) == CTetrisField::OK);
	m_pGhostMinoBlocks->GetBaseCoordinate().y -= 1;

	return;
}

bool CBasicMino::CheckTSpinCondition(CPoint2D<int> &rPt) const
{
	// ^ꂽW̎΂ߏ㉺E̍W𒲂ׂāA3_ȏɃubNTrue
	if(!m_pField){
		return false;
	}

	int count = 0;

	if(m_pField->CheckOverlap(rPt + CPoint2D<int>(1, 1)) != CTetrisField::OK){
		count++;
	}
	if(m_pField->CheckOverlap(rPt + CPoint2D<int>(-1, 1)) != CTetrisField::OK){
		count++;
	}
	if(m_pField->CheckOverlap(rPt + CPoint2D<int>(1, -1)) != CTetrisField::OK){
		count++;
	}
	if(m_pField->CheckOverlap(rPt + CPoint2D<int>(-1, -1)) != CTetrisField::OK){
		count++;
	}

	if(count >= 3){
		return true;
	}else{
		return false;
	}
}
