#ifndef BASICMINO_H
#define BASICMINO_H

#include "Mino.h"
#include "MinoBlocks.h"

class CBasicMino : public CMino
{
protected:
	// v(E)ɉx̏
	enum ERotateState {
		ROTATE0,
		ROTATE90,
		ROTATE180,
		ROTATE270
	};

	static ERotateState GetLRotatedState(ERotateState state)
	{
		switch(state){
		case ROTATE0:
			return ROTATE270;
		case ROTATE90:
		default:
			return ROTATE0;
		case ROTATE180:
			return ROTATE90;
		case ROTATE270:
			return ROTATE180;
		}
	}

	static ERotateState GetRRotatedState(ERotateState state)
	{
		switch(state){
		case ROTATE0:
			return ROTATE90;
		case ROTATE90:
			return ROTATE180;
		case ROTATE180:
			return ROTATE270;
		case ROTATE270:
		default:
			return ROTATE0;
		}
	}

public:
	CBasicMino() : m_pMinoBlocks(NULL), m_pGhostMinoBlocks(NULL), m_bLocked(false), m_rotateState(ROTATE0) {}
	virtual ~CBasicMino(){
		if(m_pGhostMinoBlocks){
			delete m_pGhostMinoBlocks;
			m_pGhostMinoBlocks = NULL;
		}
	}

	//virtual MinoResult Init(); hNXŒ`鎖
	virtual MinoResult Start();
	virtual MinoResult Left();
	virtual MinoResult Right();
	//virtual MinoResult LRotate(); hNXŒ`鎖
	//virtual MinoResult RRotate(); hNXŒ`鎖
	virtual MinoResult Down();
	virtual MinoResult HardDrop();
	virtual MinoResult Fall();
	virtual bool IsLocked() const { return m_bLocked; }
	virtual ETetrisBlockState GetBlockState(const CPoint2D<int> &rPt) const;
	virtual bool IsOnFloor(CPoint2D<int> &rPt) const;

protected:
	void UpdateGhostMinoBlocks();
	bool CheckTSpinCondition(CPoint2D<int> &rPtCenter) const;

	CMinoBlocks *m_pMinoBlocks;
	CMinoBlocks *m_pGhostMinoBlocks; // S[Xg\̂
	bool m_bLocked;
	ERotateState m_rotateState;
};

#endif // BASICMINO_H
