#ifndef ITETRISMGR_H
#define ITETRISMGR_H

#include "TetrisCommon.h"

class ITetrisMgr
{
public:
	enum EResult {
		OK,
		ERR_ARG,
		ERR_RANGE,
		ERR_NOSUPPORT,
		ERR_STATE,
		ERR_OTHER
	};

	virtual EResult OnInit()    = 0; // ՖʂۂɌĂ΂
	virtual EResult OnStart()   = 0; // ՖʂAQ[X^[gɌĂ΂
	virtual EResult OnLeft()    = 0; // Ew^ꂽɌĂ΂
	virtual EResult OnRight()   = 0; // w^ꂽɌĂ΂
	virtual EResult OnLRotate() = 0; // ]w^ꂽɌĂ΂
	virtual EResult OnRRotate() = 0; // E]w^ꂽɌĂ΂
	virtual EResult OnDown()    = 0; // (Ƃ)w^ꂽɌĂ΂
	virtual EResult OnHardDrop()= 0; // n[hhbv(Cɉ܂ŗƂ)w^ꂽĂ΂
	virtual EResult OnHold()    = 0; // z[hw^ꂽɌĂ΂
	virtual EResult OnFall()    = 0; // P}XɗƂ^C}[ExpireɌĂ΂
	virtual void GetFallTimerInterval(unsigned int &rTime, bool &rReset) = 0; // P}XɗƂ^C}[̎ԊԊuԂ
	virtual ETetrisBlockState GetBlockState(unsigned int x, unsigned int y) = 0; // W̏Ԃ𓾂
	virtual bool IsGameOver() = 0; // GameOverɂȂ𓾂

	virtual unsigned int GetLevel() = 0; // ݂̃x𓾂
	virtual unsigned int GetLines() = 0; // ܂ŏC𓾂
	virtual unsigned int GetScore() = 0; // _𓾂
	virtual ETetrisMsg GetTetrisMsg() = 0; // ŐṼbZ[W𓾂
	virtual ETetrisMino GetNextMino(unsigned int nOrder) = 0; // NextMino𓾂
	virtual ETetrisMino GetHoldMino() = 0; // HoldĂMino𓾂

	/* Configuration */
	enum ERotationSystem {
		SEGA, /* Sega Rotation */
		ARS,  /* Arika Rotation System (TGM Rotation) */
		SRS   /* Super Rotation System */
	};

	virtual ERotationSystem GetRotationSystem() = 0;
	virtual EResult SetRotationSystem(ERotationSystem system) = 0;
	virtual EResult EnableGhost(bool bEnable) = 0;
	virtual EResult SetInitialLevel(unsigned int nLevel) = 0;

	virtual ~ITetrisMgr() {}
};

ITetrisMgr* GetTetrisMgr();               // TetrisMgrCX^XԂ
void ReleaseTetrisMgr(ITetrisMgr* pMgr);  // TetrisMgr

#endif // ITETRISMGR_H
