#include "MaskedBitmap.h"

BOOL CMaskedBitmap::Create(HBITMAP hBitmapSrc, COLORREF colTransparent, HDC hdc)
{
	if(!hBitmapSrc || !hdc){
		return FALSE;
	}

	Delete();

	BITMAP bitmapSrc;
	GetObject(hBitmapSrc, sizeof(BITMAP), &bitmapSrc); // TCY𓾂邽

	// mNrbg}bv쐬
	HBITMAP hBitmapMono = CreateBitmap(bitmapSrc.bmWidth, bitmapSrc.bmHeight, 1, 1, NULL);
	HDC hDCMono = CreateCompatibleDC(hdc);
	SaveDC(hDCMono);
	SelectObject(hDCMono, hBitmapMono);

	// ̊GAmNrbg}bvɕ`悷
	HDC hDCSrc = CreateCompatibleDC(hdc);
	SaveDC(hDCSrc);
	SelectObject(hDCSrc, hBitmapSrc);
	{
		COLORREF colBkPre = SetBkColor(hDCSrc, colTransparent); // wiFݒ
		BitBlt(hDCMono, 0, 0, bitmapSrc.bmWidth, bitmapSrc.bmHeight, hDCSrc, 0, 0, SRCCOPY); // mNrbg}bvɕ`悷
		SetBkColor(hDCSrc, colBkPre);
	}

	// }XNprbg}bv쐬
	HBITMAP hBitmapMask = CreateCompatibleBitmap(hdc, bitmapSrc.bmWidth, bitmapSrc.bmHeight);
	HDC hDCMask = CreateCompatibleDC(hdc);
	SaveDC(hDCMask);
	SelectObject(hDCMask, hBitmapMask);
	BitBlt(hDCMask, 0, 0, bitmapSrc.bmWidth, bitmapSrc.bmHeight, hDCMono, 0, 0, NOTSRCCOPY); // ]ĕ`

	// ŁAŏ̃mNrbg}bv͗pς
	RestoreDC(hDCMono, -1);
	DeleteDC(hDCMono);
	DeleteObject(hBitmapMono);

	// ̊G̔wiF𔒂
	BitBlt(hDCSrc, 0, 0, bitmapSrc.bmWidth, bitmapSrc.bmHeight, hDCMask, 0, 0, MERGEPAINT);

	// GpDCpς
	RestoreDC(hDCSrc, -1);
	DeleteDC(hDCSrc);

	// MaskpDCpς
	RestoreDC(hDCMask, -1);
	DeleteDC(hDCMask);

	// XDCɖ߂
	RestoreDC(hdc, -1);

	m_hBitmapSrc = hBitmapSrc;
	m_hBitmapMask = hBitmapMask;
	m_nWidth = bitmapSrc.bmWidth;
	m_nHeight = bitmapSrc.bmHeight;

	return TRUE;
}

BOOL CMaskedBitmap::Delete()
{
	if(m_hBitmapSrc){
		DeleteObject(m_hBitmapSrc);
		m_hBitmapSrc = NULL;
	}

	if(m_hBitmapMask){
		DeleteObject(m_hBitmapMask);
		m_hBitmapMask = NULL;
	}

	return TRUE;
}

BOOL CMaskedBitmap::Draw(HDC hdc, int x, int y)
{
	if(!hdc || !m_hBitmapSrc || !m_hBitmapMask){
		return FALSE;
	}

	HDC hDCBitmap = CreateCompatibleDC(hdc);
	SaveDC(hDCBitmap);
	SelectObject(hDCBitmap, m_hBitmapMask);
	BitBlt(hdc, x, y, m_nWidth, m_nHeight, hDCBitmap, 0, 0, SRCPAINT);
	SelectObject(hDCBitmap, m_hBitmapSrc);
	BitBlt(hdc, x, y, m_nWidth, m_nHeight, hDCBitmap, 0, 0, SRCAND);
	RestoreDC(hDCBitmap, -1);
	DeleteObject(hDCBitmap);

	return TRUE;
}

