#ifndef MINO_H
#define MINO_H

#include "TetrisCommon.h"
#include "Point2D.h"
#include "TetrisField.h"

class CMino
{
public:
	typedef unsigned int MinoResult; // ̒lORԂ
	static const unsigned int SUCCESS = 0x01; // ̑삪
	static const unsigned int LOCKED  = 0x02; // ɗLock

	CMino() : m_pField(NULL), m_nHardDropHeight(0), m_bTSpin(false) {}
	virtual ~CMino() {}

	virtual MinoResult Init() = 0;     // Mino
	virtual MinoResult Start() { m_nHardDropHeight = 0; m_bTSpin = false; return SUCCESS; }    // MinoX^[gʒuɒu
	virtual MinoResult Left() = 0;     // ړ
	virtual MinoResult Right() = 0;    // Eړ
	virtual MinoResult LRotate() = 0;  // ]
	virtual MinoResult RRotate() = 0;  // E]
	virtual MinoResult Down() = 0;     // ɗƂ
	virtual MinoResult HardDrop() = 0; // ܂ŗƂ
	virtual MinoResult Fall() = 0;     // d͂ɂ艺ɗ
	virtual bool IsLocked() const = 0; // or̃ubNɗăbNǂ
	virtual ETetrisBlockState GetBlockState(const CPoint2D<int> &pt) const = 0; // Mino`悷邽߂ɌĂ΂
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_UNKNOWN; }

	void RelateTetrisField(CTetrisField *pField) { m_pField = pField; }

	virtual unsigned int GetHardDropHeight() { return m_nHardDropHeight; }
	virtual bool IsTSpin() const { return m_bTSpin; }
	virtual bool IsWallKick() const { return m_bWallKick; }
	virtual bool IsOnFloor(CPoint2D<int> &rPt) const = 0; // ܂ŗĂ邩ǂ`FbNAĂAɐGĂubNWԂ
protected:
	CTetrisField *m_pField;
	unsigned int m_nHardDropHeight;
	bool m_bTSpin;                     // ȎTSpin𖞂
	bool m_bWallKick;                  // Ỏ]Wall Kick
};

#endif // MINO_H
