#include "MinoBlocks.h"
#include <assert.h>

CMinoBlocks::CMinoBlocks(unsigned int blockNum)
{
	assert(blockNum != 0);

	m_pMinoBlockArray = new SMinoOneBlock[blockNum];
	assert(m_pMinoBlockArray != NULL);

	m_nMinoBlockNum = blockNum;
}

CMinoBlocks::CMinoBlocks(const CMinoBlocks& obj)
{
	unsigned int blockNum = obj.GetBlockNum();
	assert(blockNum != 0);

	m_pMinoBlockArray = new SMinoOneBlock[blockNum];
	assert(m_pMinoBlockArray != NULL);

	m_nMinoBlockNum = blockNum;
	Copy(obj);
}

CMinoBlocks::~CMinoBlocks()
{
	delete[] m_pMinoBlockArray;
	m_pMinoBlockArray = NULL;
}

// ʂMinoBlocksɃRs[ BlockNum̏ꍇ̂ݐ
bool CMinoBlocks::Copy(const CMinoBlocks& rSrc)
{
	if(m_nMinoBlockNum != rSrc.m_nMinoBlockNum){
		return false;
	}

	m_ptBase = rSrc.m_ptBase;

	unsigned int i = 0;
	for(i=0; i<m_nMinoBlockNum; i++){
		m_pMinoBlockArray[i] = rSrc.m_pMinoBlockArray[i];
	}

	return true;
}

// BaseWړ BaseWړ邾ŁAMinǒ`͂̂܂܂ƂȂ
void CMinoBlocks::ChangeBaseCoordinate(const CPoint2D<int>& rPt, bool isAbsolute)
{
	CPoint2D<int> vec; // ړ2xNg
	if(isAbsolute){
		// Ύw̏ꍇApt͈ړW
		vec = rPt - m_ptBase;
		m_ptBase = rPt;
	}else{
		// Ύw̏ꍇApt̂ړxNg
		vec = rPt;
		m_ptBase += rPt;
	}

	unsigned int i = 0;
	for(i=0; i<m_nMinoBlockNum; i++){
		m_pMinoBlockArray[i].point += vec; // ړxNgړ
	}
}

// indexԖڂBlock̈ʒu(/)ƏԂ𓾂
bool CMinoBlocks::GetBlock(unsigned int index, CPoint2D<int> &rPt, ETetrisBlockState &rBlockState, bool isAbsolute) const
{
	if(index >= m_nMinoBlockNum){
		return false;
	}

	if(isAbsolute){
		rPt = m_ptBase + m_pMinoBlockArray[index].point;
	}else{
		rPt = m_pMinoBlockArray[index].point;
	}
	rBlockState = m_pMinoBlockArray[index].blockState;

	return true;
}

// indexԖڂBlock̈ʒu(/)ƏԂݒ肷
bool CMinoBlocks::SetBlock(unsigned int index, const CPoint2D<int> &rPt, ETetrisBlockState blockState, bool isAbsolute)
{
	if(index >= m_nMinoBlockNum){
		return false;
	}

	if(isAbsolute){
		// Basȇ΍Wɂĕۑ
		m_pMinoBlockArray[index].point = rPt - m_ptBase;
	}else{
		m_pMinoBlockArray[index].point = rPt;
	}
	m_pMinoBlockArray[index].blockState = blockState;

	return true;
}

// WBlockStateԂ ΂ł΂łw\
ETetrisBlockState CMinoBlocks::GetBlockState(const CPoint2D<int> &rPt, bool isAbsolute) const
{
	CPoint2D<int> pt;
	if(isAbsolute){
		// ΍Wɂ
		pt = rPt - m_ptBase;
	}else{
		pt = rPt;
	}

	unsigned int i = 0;
	for(i=0; i<m_nMinoBlockNum; i++){
		if(pt == m_pMinoBlockArray[i].point){
			return m_pMinoBlockArray[i].blockState;
		}
	}

	return BLOCKSTATE_NONE;
}

// MinoABaseWSɍ]
void CMinoBlocks::LRotate()
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoBlockNum; i++){
		m_pMinoBlockArray[i].point.LRotate();
	}
}

// MinoABaseWSɉE]
void CMinoBlocks::RRotate()
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoBlockNum; i++){
		m_pMinoBlockArray[i].point.RRotate();
	}
}

// MinoABaseW+(1/2, 1/2)Sɍ]
void CMinoBlocks::LRotateC()
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoBlockNum; i++){
		m_pMinoBlockArray[i].point.LRotateC();
	}
}

// MinoABaseW+(1/2, 1/2)SɉE]
void CMinoBlocks::RRotateC()
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoBlockNum; i++){
		m_pMinoBlockArray[i].point.RRotateC();
	}
}

// Oڂ钷`Ԃ
void CMinoBlocks::GetCircumscribedRect(CPoint2D<int> &rPtTopLeft, CPoint2D<int> &rPtBottomRight, bool isAbsolute) const
{
	assert(m_nMinoBlockNum != 0);

	rPtTopLeft = m_pMinoBlockArray[0].point;
	rPtBottomRight = rPtTopLeft;

	unsigned int i = 0;
	for(i=1; i<m_nMinoBlockNum; i++){
		CPoint2D<int> ptTemp = m_pMinoBlockArray[0].point;
		if(ptTemp.x < rPtTopLeft.x){
			rPtTopLeft.x = ptTemp.x;
		}
		if(ptTemp.y < rPtTopLeft.y){
			rPtTopLeft.y = ptTemp.y;
		}
		if(ptTemp.x > rPtBottomRight.x){
			rPtBottomRight.x = ptTemp.x;
		}

		if(ptTemp.y > rPtBottomRight.y){
			rPtBottomRight.y = ptTemp.y;
		}
	}

	if(isAbsolute){
		rPtTopLeft += m_ptBase;
		rPtBottomRight += m_ptBase;
	}
}

