#include "MinoSelector.h"

#include <stdlib.h>
#include <time.h>
#include <assert.h>

CMinoSelector::CMinoSelector(unsigned int nMinoNum)
{
	assert(nMinoNum != 0);

	m_nMinoNum = nMinoNum;
	m_pMinoSelectInfo = new SMinoSelectInfo[m_nMinoNum];
	assert(m_pMinoSelectInfo != NULL);

	srand((unsigned int)time(NULL));
}

CMinoSelector::~CMinoSelector()
{
	delete[] m_pMinoSelectInfo;
}

void CMinoSelector::InitCount()
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoNum; i++){
		m_pMinoSelectInfo[i].count = 0; // JEgl
	}
}

CMino* CMinoSelector::SelectMino()
{
	unsigned int i = 0;

	// ܂countl̍ŏl߂
	unsigned int countMin = m_pMinoSelectInfo[0].count;
	for(i=1; i<m_nMinoNum; i++){
		if(m_pMinoSelectInfo[i].count < countMin){
			countMin = m_pMinoSelectInfo[i].count;
		}
	}

	// ŏcountlSĂcountlAŏcountl0ɂȂ悤ɂ
	// om߂
	double sum = 0.0;
	for(i=0; i<m_nMinoNum; i++){
		m_pMinoSelectInfo[i].count -= countMin;
		// omcountl镪Ȃ (1/(8^count))
		if(m_pMinoSelectInfo[i].count <= 31/3){
			m_pMinoSelectInfo[i].probability = 1.0 / (1 << (3*m_pMinoSelectInfo[i].count));
		}else{
			m_pMinoSelectInfo[i].probability = 0.0;
		}
		sum += m_pMinoSelectInfo[i].probability;
	}

	double randVal = (double)(rand()+1) / (double)(RAND_MAX+1);

	for(i=0; i<m_nMinoNum-1; i++){
		m_pMinoSelectInfo[i].probability /= sum;
		if(randVal >= m_pMinoSelectInfo[i].probability){
			// ܂MinoSelectȂ
			randVal -= m_pMinoSelectInfo[i].probability;
		}else{
			m_pMinoSelectInfo[i].count++;
			return m_pMinoSelectInfo[i].pMino;
		}
	}
	// ŌMinoI
	m_pMinoSelectInfo[m_nMinoNum-1].count++;
	return m_pMinoSelectInfo[m_nMinoNum-1].pMino;
}

void CMinoSelector::RelateTetrisField(CTetrisField *pField)
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoNum; i++){
		if(m_pMinoSelectInfo[i].pMino){
			m_pMinoSelectInfo[i].pMino->RelateTetrisField(pField);
		}
	}
}
