#ifndef SRSMINO_H
#define SRSMINO_H

#include "BasicMino.h"
#include "SegaRotationMino.h"

class CSRSMino : public CBasicMino
{
protected:
	struct SSRSWallKickOrder {
		unsigned int num;
		CPoint2D<int> move[4]; // 4܂Ō₪
	};

	struct SSRSWallKickTable {
		SSRSWallKickOrder from0;
		SSRSWallKickOrder from90;
		SSRSWallKickOrder from180;
		SSRSWallKickOrder from270;
	};

	static const SSRSWallKickTable s_tableIMinoL;
	static const SSRSWallKickTable s_tableIMinoR;
	static const SSRSWallKickTable s_tableCommonL;
	static const SSRSWallKickTable s_tableCommonR;
	static const SSRSWallKickTable s_tableTMinoL;
	static const SSRSWallKickTable s_tableTMinoR;

public:
	CSRSMino();
	virtual ~CSRSMino();
	virtual MinoResult LRotate();
	virtual MinoResult RRotate();
protected:
	virtual void LRotateNormal()
	{
		if(m_pMinoBlocks){
			m_pMinoBlocks->LRotate(); // IMino]@Ⴄ̂
		}
	}

	virtual void RRotateNormal()
	{
		if(m_pMinoBlocks){
			m_pMinoBlocks->RRotate(); // IMino]@Ⴄ̂
		}
	}

	const SSRSWallKickTable* m_pTableL;
	const SSRSWallKickTable* m_pTableR;
};

class CSRSIMino : public CSRSMino
{
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_CYAN;
public:
	CSRSIMino(){ m_pTableL = &s_tableIMinoL; m_pTableR = &s_tableIMinoR; }
	virtual MinoResult Init();
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_I; }
protected:
	virtual void LRotateNormal()
	{
		if(m_pMinoBlocks){
			m_pMinoBlocks->LRotateC();
		}
	}

	virtual void RRotateNormal()
	{
		if(m_pMinoBlocks){
			m_pMinoBlocks->RRotateC();
		}
	}
};

// O Mino͑S
typedef CSegaRotationOMino CSRSOMino;

class CSRSSMino : public CSRSMino
{
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_GREEN;
public:
	CSRSSMino(){ m_pTableL = &s_tableCommonL; m_pTableR = &s_tableCommonR; }
	virtual MinoResult Init();
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_S; }
};

class CSRSZMino : public CSRSMino
{
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_RED;
public:
	CSRSZMino(){ m_pTableL = &s_tableCommonL; m_pTableR = &s_tableCommonR; }
	virtual MinoResult Init();
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_Z; }
};

class CSRSJMino : public CSRSMino
{
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_BLUE;
public:
	CSRSJMino(){ m_pTableL = &s_tableCommonL; m_pTableR = &s_tableCommonR; }
	virtual MinoResult Init();
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_J; }
};

class CSRSLMino : public CSRSMino
{
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_ORANGE;
public:
	CSRSLMino(){ m_pTableL = &s_tableCommonL; m_pTableR = &s_tableCommonR; }
	virtual MinoResult Init();
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_L; }
};

class CSRSTMino : public CSRSMino
{
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_MAGENTA;
public:
	CSRSTMino(){ m_pTableL = &s_tableTMinoL; m_pTableR = &s_tableTMinoR; }
	virtual MinoResult Init();
	// TSpin̂
	virtual MinoResult LRotate();
	virtual MinoResult RRotate();
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_T; }
};

#endif // SRSMINO_H
