#include "SegaRotationMino.h"
#include <assert.h>

CSegaRotationMino::CSegaRotationMino()
{
	m_pMinoBlocks = new CMinoBlocks(4);
}

CSegaRotationMino::~CSegaRotationMino()
{
	delete m_pMinoBlocks;
}

CMino::MinoResult CSegaRotationMino::Init()
{
	if(!m_pMinoBlocks){
		return 0;
	}

	m_pMinoBlocks->GetBaseCoordinate() = CPoint2D<int>(0, 0);

	RotateMinoBlocks(ROTATE0);
	m_rotateState = ROTATE0;

	return CMino::SUCCESS;
}

CMino::MinoResult CSegaRotationMino::LRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;
	ERotateState newRotateState = GetLRotatedState(m_rotateState);

	RotateMinoBlocks(newRotateState);

	// ]o邩TetrisFieldɖ₢킹
	if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}else{
		// ]oȂ
		RotateMinoBlocks(oldRotateState);
		m_rotateState = oldRotateState;
		return 0;
	}
}

CMino::MinoResult CSegaRotationMino::RRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;
	ERotateState newRotateState = GetRRotatedState(m_rotateState);

	RotateMinoBlocks(newRotateState);

	// ]o邩TetrisFieldɖ₢킹
	if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}else{
		// ]oȂ
		RotateMinoBlocks(oldRotateState);
		m_rotateState = oldRotateState;
		return 0;
	}
}

// IMino
/*
 0, 180x̏ꍇ(FS)

 

 90, 270x̏ꍇ(FS)
 @@
 @@
 @@
 @@
*/
void CSegaRotationIMino::RotateMinoBlocks(ERotateState rotateState)
{
	assert(m_pMinoBlocks != NULL);
	assert(m_pMinoBlocks->GetBlockNum() == 4);

	switch(rotateState){
	case ROTATE0:
	case ROTATE180:
	default:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(-1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(-2, 0), s_blockState, false);
		break;
	case ROTATE90:
	case ROTATE270:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(0, -1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(0, 2), s_blockState, false);
		break;
	}
}

// OMino
/*
 0,90,180,270x̏ꍇ

@
@
*/
void CSegaRotationOMino::RotateMinoBlocks(ERotateState rotateState)
{
	assert(m_pMinoBlocks != NULL);
	assert(m_pMinoBlocks->GetBlockNum() == 4);

	m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
	m_pMinoBlocks->SetBlock(1, CPoint2D<int>(1, 0), s_blockState, false);
	m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
	m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, 1), s_blockState, false);
}

// SMino
/*
 0, 180x̏ꍇ

@@
@

 90, 270x̏ꍇ

@
@
@@
*/
void CSegaRotationSMino::RotateMinoBlocks(ERotateState rotateState)
{
	assert(m_pMinoBlocks != NULL);
	assert(m_pMinoBlocks->GetBlockNum() == 4);

	switch(rotateState){
	case ROTATE0:
	case ROTATE180:
	default:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(-1, 1), s_blockState, false);
		break;
	case ROTATE90:
	case ROTATE270:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(-1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(-1, -1), s_blockState, false);
		break;
	}
}

// ZMino
/*
 0, 180x̏ꍇ

@
@@

 90, 270x̏ꍇ

@@@
@@
@@
*/
void CSegaRotationZMino::RotateMinoBlocks(ERotateState rotateState)
{
	assert(m_pMinoBlocks != NULL);
	assert(m_pMinoBlocks->GetBlockNum() == 4);

	switch(rotateState){
	case ROTATE0:
	case ROTATE180:
	default:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(-1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, 1), s_blockState, false);
		break;
	case ROTATE90:
	case ROTATE270:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, -1), s_blockState, false);
		break;
	}
}

// JMino
/*
 0x̏ꍇ

@
@@@

 90x̏ꍇ

@@
@@
@

 180x̏ꍇ

@
@

 270x̏ꍇ

@@
@@
@@
*/
void CSegaRotationJMino::RotateMinoBlocks(ERotateState rotateState)
{
	assert(m_pMinoBlocks != NULL);
	assert(m_pMinoBlocks->GetBlockNum() == 4);

	switch(rotateState){
	case ROTATE0:
	default:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(-1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, 1), s_blockState, false);
		break;
	case ROTATE90:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(0, -1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(-1, 1), s_blockState, false);
		break;
	case ROTATE180:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(-1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(-1, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, 1), s_blockState, false);
		break;
	case ROTATE270:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(0, -1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, -1), s_blockState, false);
		break;
	}
}

// LMino
/*
 0x̏ꍇ

@
@

 90x̏ꍇ

@@
@@
@@

 180x̏ꍇ

@@
@

 270x̏ꍇ

@
@@
@@
*/
void CSegaRotationLMino::RotateMinoBlocks(ERotateState rotateState)
{
	assert(m_pMinoBlocks != NULL);
	assert(m_pMinoBlocks->GetBlockNum() == 4);

	switch(rotateState){
	case ROTATE0:
	default:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(-1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(-1, 1), s_blockState, false);
		break;
	case ROTATE90:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(0, -1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, 1), s_blockState, false);
		break;
	case ROTATE180:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(-1, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, 1), s_blockState, false);
		break;
	case ROTATE270:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(0, -1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(-1, -1), s_blockState, false);
		break;
	}
}

// TMino
/*
 0x̏ꍇ

@
@@

 90x̏ꍇ

@@
@
@@

 180x̏ꍇ

@@
@

 270x̏ꍇ

@@
@@
@@
*/
void CSegaRotationTMino::RotateMinoBlocks(ERotateState rotateState)
{
	assert(m_pMinoBlocks != NULL);
	assert(m_pMinoBlocks->GetBlockNum() == 4);

	switch(rotateState){
	case ROTATE0:
	default:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(-1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(1, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(0, 1), s_blockState, false);
		break;
	case ROTATE90:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(0, -1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(-1, 0), s_blockState, false);
		break;
	case ROTATE180:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(-1, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, 1), s_blockState, false);
		break;
	case ROTATE270:
		m_pMinoBlocks->SetBlock(0, CPoint2D<int>(0, 0), s_blockState, false);
		m_pMinoBlocks->SetBlock(1, CPoint2D<int>(0, -1), s_blockState, false);
		m_pMinoBlocks->SetBlock(2, CPoint2D<int>(0, 1), s_blockState, false);
		m_pMinoBlocks->SetBlock(3, CPoint2D<int>(1, 0), s_blockState, false);
		break;
	}
}

CMino::MinoResult CSegaRotationTMino::LRotate()
{
	MinoResult result = CSegaRotationMino::LRotate();
	if(result & CMino::SUCCESS){
		UpdateTSpinCondition();
	}
	return result;
}

CMino::MinoResult CSegaRotationTMino::RRotate()
{
	MinoResult result = CSegaRotationMino::RRotate();
	if(result & CMino::SUCCESS){
		UpdateTSpinCondition();
	}
	return result;
}

void CSegaRotationTMino::UpdateTSpinCondition()
{
	if(!m_pMinoBlocks){
		return;
	}

	CPoint2D<int> ptCenter;
	switch(m_rotateState){
	case ROTATE180:
		// ̏ꍇSʒuႤ
		ptCenter = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(0, 1);
		break;
	default:
		ptCenter = m_pMinoBlocks->GetBaseCoordinate();
		break;
	}

	// TSpin`FbN
	m_bTSpin = CheckTSpinCondition(ptCenter);
}
