#ifndef TETRISCOMMON_H
#define TETRISCOMMON_H

#ifndef NULL
#ifdef __cplusplus
#define NULL 0
#else
#define NULL ((void*)0)
#endif
#endif

#define TETRIS_BLOCKNUM_X    10 // ubN
#define TETRIS_BLOCKNUM_Y    20 // cubN

// egXKChC̐Fg
enum ETetrisBlockState {
	BLOCKSTATE_NONE,     // 
	BLOCKSTATE_CYAN,     // F (_)
	BLOCKSTATE_YELLOW,   //  (`)
	BLOCKSTATE_GREEN,    //  (S)
	BLOCKSTATE_RED,      //  (Z)
	BLOCKSTATE_BLUE,     //  (J)
	BLOCKSTATE_ORANGE,   // IW (L)
	BLOCKSTATE_MAGENTA,  //  (T)

	BLOCKSTATE_CYAN_G,     // F (_) (S[Xg)
	BLOCKSTATE_YELLOW_G,   //  (`) (S[Xg)
	BLOCKSTATE_GREEN_G,    //  (S) (S[Xg)
	BLOCKSTATE_RED_G,      //  (Z) (S[Xg)
	BLOCKSTATE_BLUE_G,     //  (J) (S[Xg)
	BLOCKSTATE_ORANGE_G,   // IW (L) (S[Xg)
	BLOCKSTATE_MAGENTA_G,  //  (T) (S[Xg)

	BLOCKSTATE_BEGIN = BLOCKSTATE_NONE,
	BLOCKSTATE_END = BLOCKSTATE_MAGENTA_G,
	BLOCKSTATE_NUM
};

enum ETetrisMino {
	TETRISMINO_UNKNOWN,   // Unknown
	TETRISMINO_I,         // F (_)
	TETRISMINO_O,         //  (`)
	TETRISMINO_S,         //  (S)
	TETRISMINO_Z,         //  (Z)
	TETRISMINO_J,         //  (J)
	TETRISMINO_L,         // IW (L)
	TETRISMINO_T,         //  (T)

	TETRISMINO_BEGIN = TETRISMINO_UNKNOWN,
	TETRISMINO_END = TETRISMINO_T,
	TETRISMINO_NUM
};

enum ETetrisMsg {
	TETRISMSG_NONE,
	TETRISMSG_SINGLE,       // 1C
	TETRISMSG_DOUBLE,       // 2C
	TETRISMSG_TRIPLE,       // 3C
	TETRISMSG_TETRIS,       // 4C
	TETRISMSG_TSPIN,        // TSpin
	TETRISMSG_TSPINSINGLE,  // TSpin + 1C
	TETRISMSG_TSPINDOUBLE,  // TSpin + 2C
	TETRISMSG_TSPINTRIPLE,  // TSpin + 3C
	TETRISMSG_TETRIS_B2B,       // 4C + Back To Back
	TETRISMSG_TSPINSINGLE_B2B,  // TSpin + 1C + Back To Back
	TETRISMSG_TSPINDOUBLE_B2B,  // TSpin + 2C + Back To Back
	TETRISMSG_TSPINTRIPLE_B2B,  // TSpin + 3C + Back To Back
	TETRISMSG_ALLCLEAR,     // ubNSď

	TETRISMSG_BEGIN = TETRISMSG_NONE,
	TETRISMSG_END = TETRISMSG_ALLCLEAR,
	TETRISMSG_NUM
};

#endif // TETRISCOMMON_H
