#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <commctrl.h>
#include <GdiPlus.h>

#include "ITetrisMgr.h"
#include "MaskedBitmap.h"

using namespace Gdiplus; // GDI+p

// Defines
#define BLOCK_SIZE 30                     // 1ubN̑傫(pixel)
#define TETRIS_TIMER_FALL   100           // 鎞Ԃv^C}ID
#define TETRIS_TIMER_BTNCHK 101           // {^͂`FbN^C}ID
#define TETRIS_BTNCHK_INTERVAL (1000/30)  // {^̓`FbN̎ԊԊu

// Global
static TCHAR g_strIniFilePath[_MAX_PATH]; // Init@C̃pX
static HINSTANCE g_hInstance;    // ̃AvP[VHINSTANCE
static HWND g_hMainWindow;       // CEChẼnh
static HBITMAP g_hMemBitmap;     // _uobt@OpBitmapIuWFNg
static HIMAGELIST g_hImageListBlock;  // C[WXg(ubN)̃nh
static HIMAGELIST g_hImageListNumber; // C[WXg(ԍ)̃nh
static HIMAGELIST g_hImageListMessage; // C[WXg(bZ[W)̃nh
static HIMAGELIST g_hImageListMinoIcon; // C[WXg(MinoIcon)̃nh
static ITetrisMgr *g_pTetrisMgr; // TetrisMgrIuWFNgւ̃|C^

static HBITMAP g_hBackGroundBitmap = NULL;

static CMaskedBitmap g_MainWndBitmap;
#define MAINWNDBMP_WIDTH        585
#define MAINWNDBMP_HEIGHT       617
#define MAINWNDBMP_TETRISAREA_X 101
#define MAINWNDBMP_TETRISAREA_Y 7
#define MAINWNDBMP_LEVELAREA_X  415
#define MAINWNDBMP_LEVELAREA_Y  397
#define MAINWNDBMP_LINESAREA_X  415
#define MAINWNDBMP_LINESAREA_Y  455
#define MAINWNDBMP_SCOREAREA_X  415
#define MAINWNDBMP_SCOREAREA_Y  512
#define MAINWNDBMP_MESSAGEAREA_X 430
#define MAINWNDBMP_MESSAGEAREA_Y 547
#define MAINWNDBMP_NEXT1AREA_X  425
#define MAINWNDBMP_NEXT1AREA_Y  35
#define MAINWNDBMP_NEXT2AREA_X  508
#define MAINWNDBMP_NEXT2AREA_Y  25
#define MAINWNDBMP_NEXT3AREA_X  508
#define MAINWNDBMP_NEXT3AREA_Y  92
#define MAINWNDBMP_NEXT4AREA_X  508
#define MAINWNDBMP_NEXT4AREA_Y  159
#define MAINWNDBMP_NEXT5AREA_X  508
#define MAINWNDBMP_NEXT5AREA_Y  226
#define MAINWNDBMP_NEXT6AREA_X  508
#define MAINWNDBMP_NEXT6AREA_Y  293
#define MAINWNDBMP_HOLDAREA_X   15
#define MAINWNDBMP_HOLDAREA_Y   34

#define NUMBMP_WIDTH            16
#define NUMBMP_HEIGHT           22
#define MESSAGEBMP_WIDTH        128
#define MESSAGEBMP_HEIGHT       64
#define MINOICONBMP_WIDTH       64
#define MINOICONBMP_HEIGHT      64

typedef struct tagSKeyConfig
{
	int left;
	int right;
	int down;
	int lRotate;
	int rRotate;
	int hardDrop;
	int hold;
	int pause;
} SKeyConfig;

static SKeyConfig g_keyConfig;

//==============================================================================================
// Init@C쐬A܂łCurrent DirectoryAexȅꏊɐݒ肷
//==============================================================================================
BOOL MakeIniFileName(LPTSTR pName, unsigned int nSize)
{
	TCHAR path_buffer[_MAX_PATH];
	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
	TCHAR fname[_MAX_FNAME];
	TCHAR ext[_MAX_EXT];

	if(GetModuleFileName(NULL, path_buffer, _MAX_PATH) == 0){
		return FALSE;
	}
	_tsplitpath_s(path_buffer, drive, dir, fname, ext);
	_tmakepath_s(path_buffer, drive, dir, NULL, NULL);
	SetCurrentDirectory(path_buffer);
	TCHAR ext2[] = _T("ini");
	_tmakepath_s(path_buffer, drive, dir, fname, ext2);

	_tcsncpy_s(pName, nSize, path_buffer, _TRUNCATE);
	return TRUE;
}

// ԍ`ʊ֐
static void DrawNumber(HDC hdc, int cx, int cy, unsigned int num){
	unsigned int i = 0;
	unsigned int nDisplay = 0;
	// ԍ͏\
	for(i=0; i<10; i++){
		nDisplay = num % 10;
		num /= 10;

		ImageList_Draw(g_hImageListNumber, (int)nDisplay, hdc, cx + (10 - i - 1)*NUMBMP_WIDTH, cy, ILD_NORMAL);

		if(num == 0){
			break;
		}
	}
}

static bool UpdateBackGround(unsigned int nLevel)
{
	TCHAR strLevel[16];
	_stprintf_s(strLevel, _T("%d"), nLevel);

	TCHAR strPath[_MAX_PATH];
	GetPrivateProfileString(_T("BackGround"), strLevel, _T(""), strPath, _MAX_PATH, g_strIniFilePath);
	if(_tcsnlen(strPath, _MAX_PATH) <= 0){
		return false;
	}

	Bitmap *pBitmap = NULL;
#ifdef _UNICODE
	pBitmap = Bitmap::FromFile(strPath, TRUE);
#else
	WCHAR wstrPath[_MAX_PATH];
	MultiByteToWideChar(CP_ACP, 0, strPath, -1, wstrPath, MAX_PATH);
	pBitmap = Bitmap::FromFile(wstrPath);
#endif
	if(!pBitmap){
		return false;
	}

	Color c;
	c.SetFromCOLORREF(RGB(0, 0, 0));
	pBitmap->GetHBITMAP(c, &g_hBackGroundBitmap);
	delete pBitmap;

	return true;
}

static void TetrisMgrSetup()
{
	ITetrisMgr::ERotationSystem rotationSystem = (ITetrisMgr::ERotationSystem)
		GetPrivateProfileInt(_T("TetrisRule"), _T("RotationSystem"), (INT)ITetrisMgr::SRS, g_strIniFilePath);
	bool bGhostEnable = GetPrivateProfileInt(_T("TetrisRule"), _T("Ghost"), 1, g_strIniFilePath) ? true : false;
	unsigned int nInitialLevel = GetPrivateProfileInt(_T("TetrisRule"), _T("InitialLevel"), 1, g_strIniFilePath);

	g_pTetrisMgr->SetRotationSystem(rotationSystem);
	g_pTetrisMgr->EnableGhost(bGhostEnable);
	g_pTetrisMgr->SetInitialLevel(nInitialLevel);
}

static void TetrisKeySetup()
{
	g_keyConfig.left = GetPrivateProfileInt(_T("KeyConfig"), _T("LEFT"), (int)VK_LEFT, g_strIniFilePath);
	g_keyConfig.right = GetPrivateProfileInt(_T("KeyConfig"), _T("RIGHT"), (int)VK_RIGHT, g_strIniFilePath);
	g_keyConfig.down = GetPrivateProfileInt(_T("KeyConfig"), _T("DOWN"), (int)VK_DOWN, g_strIniFilePath);
	g_keyConfig.lRotate = GetPrivateProfileInt(_T("KeyConfig"), _T("LROTATE"), (int)'Z', g_strIniFilePath);
	g_keyConfig.rRotate = GetPrivateProfileInt(_T("KeyConfig"), _T("RROTATE"), (int)'X', g_strIniFilePath);
	g_keyConfig.hardDrop = GetPrivateProfileInt(_T("KeyConfig"), _T("HARDDROP"), (int)VK_UP, g_strIniFilePath);
	g_keyConfig.hold = GetPrivateProfileInt(_T("KeyConfig"), _T("HOLD"), (int)VK_SHIFT, g_strIniFilePath);
	g_keyConfig.pause = GetPrivateProfileInt(_T("KeyConfig"), _T("PAUSE"), (int)VK_SPACE, g_strIniFilePath);
}

// bZ[Wnh
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch(msg) {
		case WM_CREATE: {
			InitCommonControls(); // C[WXgg߂ɕKv炵

			HDC hdc = GetDC(hWnd);
			// _uobt@OpBitmap쐬
			g_hMemBitmap = CreateCompatibleBitmap(hdc, MAINWNDBMP_WIDTH, MAINWNDBMP_HEIGHT);
			// ubÑC[WXg쐬
			HBITMAP hBitmap;
			hBitmap = LoadBitmap(g_hInstance, _T("BLOCKS"));
			g_hImageListBlock = ImageList_Create(BLOCK_SIZE, BLOCK_SIZE, ILC_COLOR | ILC_MASK, BLOCKSTATE_NUM, 0);
			ImageList_AddMasked(g_hImageListBlock, hBitmap, RGB(192, 192, 192));
			DeleteObject(hBitmap);
			// ԍ̃C[WXg쐬
			hBitmap = LoadBitmap(g_hInstance, _T("NUMBER"));
			g_hImageListNumber = ImageList_Create(NUMBMP_WIDTH, NUMBMP_HEIGHT, ILC_COLOR | ILC_MASK, 10, 0);
			ImageList_AddMasked(g_hImageListNumber, hBitmap, RGB(192, 192, 192));
			DeleteObject(hBitmap);
			// bZ[W\pC[WXg쐬
			hBitmap = LoadBitmap(g_hInstance, _T("MESSAGE"));
			g_hImageListMessage = ImageList_Create(MESSAGEBMP_WIDTH, MESSAGEBMP_HEIGHT, ILC_COLOR | ILC_MASK, TETRISMSG_NUM, 0);
			ImageList_AddMasked(g_hImageListMessage, hBitmap, RGB(192, 192, 192));
			DeleteObject(hBitmap);
			// MinoIconpC[WXg쐬
			hBitmap = LoadBitmap(g_hInstance, _T("MINOICON"));
			g_hImageListMinoIcon = ImageList_Create(MINOICONBMP_WIDTH, MINOICONBMP_HEIGHT, ILC_COLOR | ILC_MASK, TETRISMINO_NUM, 0);
			ImageList_AddMasked(g_hImageListMinoIcon, hBitmap, RGB(192, 192, 192));
			DeleteObject(hBitmap);
			// CEChEpBitmap쐬
			g_MainWndBitmap.Create(LoadBitmap(g_hInstance, _T("MAINWND")), RGB(192, 192, 192), hdc);
			ReleaseDC(hWnd, hdc);
			break;
		}
		case WM_TIMER: {
			unsigned int nFallIntervalPre = 0;
			{
				bool bReset = false;
				g_pTetrisMgr->GetFallTimerInterval(nFallIntervalPre, bReset);
			}
			unsigned int nLevelPre = g_pTetrisMgr->GetLevel();

			// wParam̒lŁAǂ̃^C}[ɂ郁bZ[W
			switch(wParam){
			case TETRIS_TIMER_BTNCHK:
				// ZԊԊuŁÃL[Ă邩̃`FbNsĂ
				// Ăꍇɂ́ATetrisMgrɂ̎|ʒmAĕ`悷悤Ɏw
				{
					SHORT keyState = 0;
					if((keyState = GetAsyncKeyState(g_keyConfig.left)) & 0x8001){ // ςȂT|[g
						static unsigned int count = 0; // ςȂɂ̓쒲Ɏg
						if((keyState & 0x0001) || (count == 0)){
							// L[ꍇKɓ
							// L[ςȂɂꍇAxԈ
							g_pTetrisMgr->OnLeft();
							InvalidateRect(hWnd, NULL, false);
							count = 0;
						}
						count = (count + 1) % 2;
					}
					
					if((keyState = GetAsyncKeyState(g_keyConfig.right)) & 0x8001){ // ςȂT|[g
						static unsigned int count = 0; // ςȂɂ̓쒲Ɏg
						if((keyState & 0x0001) || (count == 0)){
							// L[ꍇKɓ
							// L[ςȂɂꍇAxԈ
							g_pTetrisMgr->OnRight();
							InvalidateRect(hWnd, NULL, false);
							count = 0;
						}
						count = (count + 1) % 2;
					}

					if(GetAsyncKeyState(g_keyConfig.down) & 0x8000){ // ςȂT|[g
						g_pTetrisMgr->OnDown();
						InvalidateRect(hWnd, NULL, false);
					}
					
					if(GetAsyncKeyState(g_keyConfig.lRotate) & 0x0001){
						g_pTetrisMgr->OnLRotate();
						InvalidateRect(hWnd, NULL, false);
					}
					
					if(GetAsyncKeyState(g_keyConfig.rRotate) & 0x0001){
						g_pTetrisMgr->OnRRotate();
						InvalidateRect(hWnd, NULL, false);
					}

					if(GetAsyncKeyState(g_keyConfig.hardDrop) & 0x0001){
						g_pTetrisMgr->OnHardDrop();
						InvalidateRect(hWnd, NULL, false);
					}
					
					if(GetAsyncKeyState(g_keyConfig.hold) & 0x0001){
						g_pTetrisMgr->OnHold();
						InvalidateRect(hWnd, NULL, false);
					}

					if(GetAsyncKeyState(g_keyConfig.pause) & 0x0001){
						// ^C}[~
						KillTimer(g_hMainWindow, TETRIS_TIMER_FALL);
						KillTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK);

						MessageBox(g_hMainWindow, _T("Pause"), _T("Pause"), MB_OK | MB_ICONINFORMATION);

						// ^C}[ăX^[g
						{
							unsigned int nTime = 0;
							bool bReset = false;
							g_pTetrisMgr->GetFallTimerInterval(nTime, bReset);
							SetTimer(g_hMainWindow, TETRIS_TIMER_FALL, nTime, NULL);
							SetTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK, TETRIS_BTNCHK_INTERVAL, NULL);
						}
					}
				}
				break;
			case TETRIS_TIMER_FALL:
				// P}X鎞Ԃ̃^C}[̏ꍇ
				g_pTetrisMgr->OnFall();
				InvalidateRect(hWnd, NULL, false);
				break;
			default:
				break;
			}
			if(g_pTetrisMgr->IsGameOver()){
				// Q[I[o[ƕꍇ̏s
				TCHAR message[256];
				// ^C}[~
				KillTimer(g_hMainWindow, TETRIS_TIMER_FALL);
				KillTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK);
				_stprintf_s(message, sizeof(message)/sizeof(message[0]), _T("Game Over. (Score: %d)  Retry?"), g_pTetrisMgr->GetScore());
				// bZ[W{bNXoāA[U[ɏI邩ǂIĂ炤
				if(MessageBox(g_hMainWindow, message, _T("Game Over"), MB_OKCANCEL | MB_ICONINFORMATION) == IDOK){
					// ēxX^[g̏ꍇ
					// TetrisMgrɏʒm
					g_pTetrisMgr->OnInit();
					g_pTetrisMgr->OnStart();
					// wiݒ肷(xɈԋ߂wiݒ
					{
						unsigned int nInitialLevel= g_pTetrisMgr->GetLevel();
						unsigned int i = 0;
						for(i=nInitialLevel; i>0; i--){
							if(UpdateBackGround(i)){
								break;
							}
						}
					}
					InvalidateRect(hWnd, NULL, false); // ĕ`w
					// xGetAsyncKeyStateĂԂƂŁAȑÕL[NA
					GetAsyncKeyState(g_keyConfig.left);
					GetAsyncKeyState(g_keyConfig.right);
					GetAsyncKeyState(g_keyConfig.down);
					GetAsyncKeyState(g_keyConfig.lRotate);
					GetAsyncKeyState(g_keyConfig.rRotate);
					GetAsyncKeyState(g_keyConfig.hold);
					GetAsyncKeyState(g_keyConfig.hardDrop);
					GetAsyncKeyState(g_keyConfig.pause);
					// ^C}[ăX^[g
					{
						unsigned int nTime = 0;
						bool bReset = false;
						g_pTetrisMgr->GetFallTimerInterval(nTime, bReset);
						SetTimer(g_hMainWindow, TETRIS_TIMER_FALL, nTime, NULL);
						SetTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK, TETRIS_BTNCHK_INTERVAL, NULL);
					}
				}else{
					// Î߂̃bZ[W𓊂
					PostMessage(g_hMainWindow, WM_CLOSE, 0, 0);
				}
			}else{
				if(nLevelPre != g_pTetrisMgr->GetLevel()){
					// xω
					UpdateBackGround(g_pTetrisMgr->GetLevel());
				}
				
				unsigned int nTime = 0;
				bool bReset = false;
				g_pTetrisMgr->GetFallTimerInterval(nTime, bReset);
				if(bReset || (nFallIntervalPre != nTime)){
					// TetrisMgrwA鎞ԊԊuύXɂȂ
					// x^C}[~߂āAԕύXčăX^[gĂ
					KillTimer(g_hMainWindow, TETRIS_TIMER_FALL);
					SetTimer(g_hMainWindow, TETRIS_TIMER_FALL, nTime, NULL);
				}
			}
			break;
		}
		case WM_PAINT: {
			// EChE̕`揈
			// Windows̕`揈́ÃbZ[Wɂ̂ݍsA
			// ̃bZ[W̏ɕ`悷邱Ƃ͍sȂ悤Ɏ̂
			// ĕ`x̂ȂAInvalidateRectgΗǂ
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hWnd, &ps);

			// _uobt@Ô߂Bitmapɕ`߂DC𐶐
			// ڃEChEɃubN`Ă܂ƁAubN`Ăߒ
			// Ă܂ĉ̂ŁAxŃubN`A
			// xɃEChEɕ`悷悤Ɏ
			HDC hMemDC = CreateCompatibleDC(hdc);
			SaveDC(hMemDC);
			SelectObject(hMemDC, g_hMemBitmap);
			// hԂ
			PatBlt(hMemDC, 0, 0, MAINWNDBMP_WIDTH, MAINWNDBMP_HEIGHT, BLACKNESS);

			if(g_hBackGroundBitmap){
				HDC hDCBitmap = CreateCompatibleDC(hdc);
				SaveDC(hDCBitmap);
				SelectObject(hDCBitmap, g_hBackGroundBitmap);
				BitBlt(hMemDC, 0, 0, MAINWNDBMP_WIDTH, MAINWNDBMP_HEIGHT, hDCBitmap, 0, 0, SRCCOPY);
				RestoreDC(hDCBitmap, -1);
				DeleteObject(hDCBitmap);
			}

			// CEChE`
			g_MainWndBitmap.Draw(hMemDC, 0, 0);

			for(int x = 0; x < TETRIS_BLOCKNUM_X; x++) {
				for(int y = 0; y < TETRIS_BLOCKNUM_Y; y++) {
					// C[WXgPubN̉摜𔲂oĕ`
					ImageList_Draw(g_hImageListBlock, (int)g_pTetrisMgr->GetBlockState(x, y),
						hMemDC, MAINWNDBMP_TETRISAREA_X + x * BLOCK_SIZE, MAINWNDBMP_TETRISAREA_Y + y * BLOCK_SIZE, ILD_NORMAL);
				}
			}

			// x/C/_`
			DrawNumber(hMemDC, MAINWNDBMP_LEVELAREA_X, MAINWNDBMP_LEVELAREA_Y, g_pTetrisMgr->GetLevel());
			DrawNumber(hMemDC, MAINWNDBMP_LINESAREA_X, MAINWNDBMP_LINESAREA_Y, g_pTetrisMgr->GetLines());
			DrawNumber(hMemDC, MAINWNDBMP_SCOREAREA_X, MAINWNDBMP_SCOREAREA_Y, g_pTetrisMgr->GetScore());

			// bZ[W`
			ImageList_Draw(g_hImageListMessage, (int)g_pTetrisMgr->GetTetrisMsg(),
				hMemDC, MAINWNDBMP_MESSAGEAREA_X, MAINWNDBMP_MESSAGEAREA_Y, ILD_NORMAL);

			// NextMino`
			ImageList_Draw(g_hImageListMinoIcon, (int)g_pTetrisMgr->GetNextMino(0),
				hMemDC, MAINWNDBMP_NEXT1AREA_X, MAINWNDBMP_NEXT1AREA_Y, ILD_NORMAL);
			ImageList_Draw(g_hImageListMinoIcon, (int)g_pTetrisMgr->GetNextMino(1),
				hMemDC, MAINWNDBMP_NEXT2AREA_X, MAINWNDBMP_NEXT2AREA_Y, ILD_NORMAL);
			ImageList_Draw(g_hImageListMinoIcon, (int)g_pTetrisMgr->GetNextMino(2),
				hMemDC, MAINWNDBMP_NEXT3AREA_X, MAINWNDBMP_NEXT3AREA_Y, ILD_NORMAL);
			ImageList_Draw(g_hImageListMinoIcon, (int)g_pTetrisMgr->GetNextMino(3),
				hMemDC, MAINWNDBMP_NEXT4AREA_X, MAINWNDBMP_NEXT4AREA_Y, ILD_NORMAL);
			ImageList_Draw(g_hImageListMinoIcon, (int)g_pTetrisMgr->GetNextMino(4),
				hMemDC, MAINWNDBMP_NEXT5AREA_X, MAINWNDBMP_NEXT5AREA_Y, ILD_NORMAL);
			ImageList_Draw(g_hImageListMinoIcon, (int)g_pTetrisMgr->GetNextMino(5),
				hMemDC, MAINWNDBMP_NEXT6AREA_X, MAINWNDBMP_NEXT6AREA_Y, ILD_NORMAL);
			// HoldMino`
			ImageList_Draw(g_hImageListMinoIcon, (int)g_pTetrisMgr->GetHoldMino(),
				hMemDC, MAINWNDBMP_HOLDAREA_X, MAINWNDBMP_HOLDAREA_Y, ILD_NORMAL);

			// `BitmapWindowɈCɕ`悷
			BitBlt(hdc, 0, 0, MAINWNDBMP_WIDTH, MAINWNDBMP_HEIGHT, hMemDC, 0, 0, SRCCOPY);
			RestoreDC(hMemDC, -1);
			DeleteObject(hMemDC);

			EndPaint(hWnd, &ps);
			break;
		}
		case WM_DESTROY: {
			// Ȉ
			ImageList_Destroy(g_hImageListBlock);
			ImageList_Destroy(g_hImageListNumber);
			ImageList_Destroy(g_hImageListMessage);
			ImageList_Destroy(g_hImageListMinoIcon);
			DeleteObject(g_hMemBitmap);
			if(g_hBackGroundBitmap){
				DeleteObject(g_hBackGroundBitmap);
			}
			g_MainWndBitmap.Delete();
			
			PostQuitMessage(0);
			break;
		}
		default:
			return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}

int APIENTRY _tWinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPTSTR cmdLine, int cmdShow)
{
    g_hInstance = hInst;

    GdiplusStartupInput gdiplusStartupInput;
    ULONG_PTR gdiplusToken;

    // GDI+̏
    GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);

	// Init@C쐬
	if(!MakeIniFileName(g_strIniFilePath, sizeof(g_strIniFilePath)/sizeof(g_strIniFilePath[0]))){
		return -1;
	}

	TetrisKeySetup();

	// TetrisMgr𓾂
	g_pTetrisMgr = GetTetrisMgr();
	if(!g_pTetrisMgr){
		return -1;
	}
	TetrisMgrSetup();

	// wiݒ肷(xɈԋ߂wiݒ
	{
		unsigned int nInitialLevel= g_pTetrisMgr->GetLevel();
		unsigned int i = 0;
		for(i=nInitialLevel; i>0; i--){
			if(UpdateBackGround(i)){
				break;
			}
		}
	}

	g_pTetrisMgr->OnInit();
	g_pTetrisMgr->OnStart();

	WNDCLASSEX wc;                                 // `p̍\
	static LPCTSTR pClassName = _T("Tetris");      // NX

	wc.cbSize        = sizeof(WNDCLASSEX);         // \̃TCY
	wc.style         = CS_HREDRAW | CS_VREDRAW;    // NXX^C
	wc.lpfnWndProc   = (WNDPROC)WndProc;
	wc.cbClsExtra    = 0;                          // ⑫ubN
	wc.cbWndExtra    = 0;                          //   ̃TCY
	wc.hInstance     = hInst;                      // CX^X
	wc.hIcon         = LoadIcon(hInst, _T("TETRISICON"));
	wc.hCursor       = LoadCursor(NULL,IDC_ARROW); // J[\
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);   // wiF
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = pClassName;                 // NX
	wc.hIconSm       = NULL;
	if (!RegisterClassEx(&wc)) return FALSE;       // o^

	// NCAg̈̈ʒuƃTCY̎w肩A
	// ̏𖞂߂ɕKvȁAEBhËʒuƃTCYvZ
	RECT r;
	r.left = r.top = 0;
	r.right = MAINWNDBMP_WIDTH;
	r.bottom = MAINWNDBMP_HEIGHT;
	AdjustWindowRectEx(&r, WS_OVERLAPPED | WS_MINIMIZEBOX | WS_SYSMENU | WS_CAPTION, false, 0);

	// EChE
	g_hMainWindow = CreateWindow(pClassName, _T("Tetris"), WS_OVERLAPPED | WS_MINIMIZEBOX | WS_SYSMENU | WS_CAPTION,
    				CW_USEDEFAULT, CW_USEDEFAULT, r.right - r.left, r.bottom - r.top,
    				NULL, NULL, hInst, NULL);

	ShowWindow(g_hMainWindow, SW_SHOW);

	MessageBox(g_hMainWindow, _T("Ready?"), _T("Start"), MB_OK | MB_ICONINFORMATION);

	// ^C}[X^[g
	{
		unsigned int nTime = 0;
		bool bReset = false;
		g_pTetrisMgr->GetFallTimerInterval(nTime, bReset);
		SetTimer(g_hMainWindow, TETRIS_TIMER_FALL, nTime, NULL);
		SetTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK, TETRIS_BTNCHK_INTERVAL, NULL);
	}

	// bZ[WfBXpb`
	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	KillTimer(g_hMainWindow, TETRIS_TIMER_FALL);
	KillTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK);

	ReleaseTetrisMgr(g_pTetrisMgr);
	g_pTetrisMgr = NULL;

    // GDI+̌㏈
    GdiplusShutdown(gdiplusToken);

	return 0;
}
