#ifndef TETRISMGR_H
#define TETRISMGR_H

#include "ITetrisMgr.h"
#include "Mino.h"
#include "MinoSelector.h"
#include "TetrisField.h"
#include "TetrisOnFloorChecker.h"

class CTetrisMgr : public ITetrisMgr
{
public:
	CTetrisMgr();
	virtual ~CTetrisMgr();

	// z֐̃I[o[Ch
	virtual EResult OnInit();      // ՖʂۂɌĂ΂
	virtual EResult OnStart();     // ՖʂAQ[X^[gɌĂ΂
	virtual EResult OnLeft();      // Ew^ꂽɌĂ΂
	virtual EResult OnRight();     // w^ꂽɌĂ΂
	virtual EResult OnLRotate();   // ]w^ꂽɌĂ΂
	virtual EResult OnRRotate();   // E]w^ꂽɌĂ΂
	virtual EResult OnDown();      // (Ƃ)w^ꂽɌĂ΂
	virtual EResult OnHardDrop();  // Cɉ܂ŗƂw^ꂽƂɌĂ΂
	virtual EResult OnHold();      // z[hw^ꂽɌĂ΂
	virtual EResult OnFall();      // P}XɗƂ^C}[ExpireɌĂ΂
	virtual void GetFallTimerInterval(unsigned int &rTime, bool &rReset); // P}XɗƂ^C}[̎ԊԊuԂ
	virtual ETetrisBlockState GetBlockState(unsigned int x, unsigned int y); // W̏Ԃ𓾂
	virtual bool IsGameOver() { return m_bGameOver; } // GameOverɂȂ𓾂

	virtual unsigned int GetLevel()
	{
		unsigned int n = m_nLineCleared / 10 + m_nInitialLevel;
		if(n < 1){ n = 1; }
		if(n > 20){ n = 20; }
		return n;
	}

	virtual unsigned int GetLines() { return m_nLineCleared; }
	virtual unsigned int GetScore() { return m_nScore; }
	virtual ETetrisMsg GetTetrisMsg() { return m_tetrisMsg; }
	virtual ETetrisMino GetNextMino(unsigned int nOrder){
		if(nOrder >= sizeof(m_aMinoNext)/sizeof(m_aMinoNext[0])){
			return TETRISMINO_UNKNOWN;
		}else{
			return m_aMinoNext[nOrder]->GetTetrisMinoEnum();
		}
	}
	virtual ETetrisMino GetHoldMino(){
		if(m_pMinoHold){
			return m_pMinoHold->GetTetrisMinoEnum();
		}else{
			return TETRISMINO_UNKNOWN;
		}
	}

	/* Configuration */
	virtual ERotationSystem GetRotationSystem() { return m_rotationSystem; }
	virtual EResult SetRotationSystem(ERotationSystem system);
	virtual EResult EnableGhost(bool bEnable) { m_bGhostEnable = bEnable; return ITetrisMgr::OK; }
	virtual EResult SetInitialLevel(unsigned int nLevel)
		{ m_nInitialLevel = nLevel; if(m_nInitialLevel < 1){ m_nInitialLevel = 1; } return ITetrisMgr::OK; }

protected:
	void CheckAndHandleMinoLock(); // Mino`FbNāAKX
	void RefreshMinos(); // Mino̍ď[U
	void UpdateMinos();  // Mino𐶐

protected:
	CMino         *m_pMinoCurrent;  // ݕ\Mino
	CMino         *m_pMinoHold;     // HoldMino
	CMino*        m_aMinoNext[6];   // ɕ\Mino
	CMinoSelector *m_pMinoSelector; // MinoIł
	CTetrisField  m_tetrisField;    // Ֆʂ̏(MinoȊÕubN)ێ
	CTetrisOnFloorChecker m_onFloorChecker;

	bool          m_bGameOver;      // GameOverɂȂǂ
	bool          m_bHoldDone;      // Holdォǂ
	bool          m_bMinoOnFloor;   // ݃ubN/MinoĂ邩ǂ
	bool          m_bFallTimerReset;// FallTimerZbgKvL邩ǂ
	unsigned int  m_nScore;         // _
	unsigned int  m_nLineCleared;   // ܂ŏC
	bool          m_bB2BEnable;     // Back To BacktO
	ETetrisMsg    m_tetrisMsg;      // \ׂbZ[W

	ERotationSystem m_rotationSystem; // RotationSystem̎
	bool          m_bGhostEnable;   // Ghost\邩ǂ
	unsigned int  m_nInitialLevel;  // ŏ̃x
};

#endif // TETRISMGR_H
